/*
	Engineering Test: Boggle Solver
	Gordon Lee

*******************************************************************************

	@filename	BoggleSolver.h

	@description
		Function for solving all valid words in a Boggle board from a dictionary

	@author		Gordon Lee
*/

#ifndef BOGGLESOLVER_H
#define BOGGLESOLVER_H
#pragma once

// Includes
#include <string>
#include "cList.h"
#include "cBoard.h"
#include "cDictionary.h"

#define NULL 0

// Namespace
namespace Test
{
////////////////////////////////////////////////////////////////////////////////
struct sBoggleSolverInfo
{
	cList<std::string> *m_validWords;
	char *m_wordBuffer;
	int m_wordIndex;
	cBoard *m_board;
	int m_currBoardPosR;
	int m_currBoardPosC;
	char *m_boardState;
	cDictionary *m_dictionary;
};

cList<std::string> *BoggleSolver(cBoard *_board, cDictionary *_dictionary);
void RecursiveBoggleSolver(sBoggleSolverInfo &_info, sTrieNode *_nodeRef);
////////////////////////////////////////////////////////////////////////////////
}

#endif
