/*
	Engineering Test: Boggle Solver
	Gordon Lee

*******************************************************************************

	@filename	cList.h

	@description
		Class for a singly linked list of templatized nodes

	@author		Gordon Lee
*/

#ifndef C_LIST_H
#define C_LIST_H
#pragma once

// Defines
#define NULL 0

// Namespace
namespace Test
{
////////////////////////////////////////////////////////////////////////////////
template <class T>
class cList
{
public:
			cList();
			~cList();

	bool	Empty(void);
	bool	Find(T _data);
	T		Front(void);
	T		Pop_Front(void);
	void	Push_Back(T _data);
	size_t	Size(void);

private:
	// Node struct
	struct sNode
	{
		T m_data;
		sNode *m_next;
	};

	// Data members
	sNode *m_head;
	sNode *m_tail;
	size_t m_size;
};
////////////////////////////////////////////////////////////////////////////////
}

// Includes
#include "cList.cpp"

#endif
