/*
	Engineering Test: Boggle Solver
	Gordon Lee

*******************************************************************************

	@filename	cTrie.h

	@description
		Class for a trie (prefix tree) graph

	@author		Gordon Lee
*/

#ifndef C_TRIE_H
#define C_TRIE_H
#pragma once

// Defines
#define NULL 0

// Namespace
namespace Test
{
////////////////////////////////////////////////////////////////////////////////
// Defines
#define LETTER_SEARCHING	0
#define LETTER_NOTFOUND		1
#define LETTER_FOUND		2

// Node struct
struct sTrieNode
{
	void *operator new(size_t _size);
	void operator delete(void *_p, size_t _size);

	char m_char;
	sTrieNode *m_child;
	sTrieNode *m_sibling;
	bool m_bEOW;
};

class cTrie
{
public:
				cTrie();
				~cTrie();

	sTrieNode *	Head(void);
	void		Insert(char *_word, int _wordIndex, sTrieNode *_nodeRef);
	void		Delete(sTrieNode *_nodeRef);

private:
	// Data members
	sTrieNode *m_head;
	size_t m_size;
};
////////////////////////////////////////////////////////////////////////////////
}

#endif
